function [betahat,stdbeta, iter, converge]=PMGe(Y,X,p)

% y is T x n matrix of observations on the dependent variable
% x is T x n x k matrix of observations on regressors
% it is allowed for NaNs (at the begining or end)


[T,n]=size(Y);
k=size(X,3);
% initial estimator 

%E-G pooled

A=0; B=0;

for i=1:n
    xi=squeeze(X(:,i,:));
    yi=Y(:,i);
 % find available sample (time periods with NaNs are dropped)
 ni=isnan([yi,xi]);
 omit=(sum(ni,2)>0);
 yi=yi(not(omit));
 xi=xi(not(omit),:);
 Ti=size(yi,1);

tau=ones(Ti,1);
Mh=eye(Ti)-tau*(inv(tau'*tau))*tau';

    A=A + xi'*Mh*xi;
    B=B + xi'*Mh*yi;
end

beta=inv(A)*B;

% 2. compute phihats and sigmais
phi=zeros(n,1);
sigi2=zeros(n,1);
for i=1:n
    [exi,Hi,dyi,Xi,yi_, Ti]=getvars(i,X,Y,p,beta);

  phi(i,1)=inv(exi'*Hi*exi)*exi'*Hi*dyi;
  sigi2(i,1)=(dyi-phi(i,1)*exi)'*Hi*(dyi-phi(i,1)*exi)/(Ti-p);
end


%now repeat

converge=false;
precision=1e-4;
maxiter=500;
iter=0;

while iter<maxiter && not(converge)
   %1. new beta 
   A=zeros(k,k);
   b=zeros(k,1);
   for i=1:n
       [exi,Hi,dyi,Xi,yi_, Ti]=getvars(i,X,Y,p,beta);
        

      A=A-phi(i,1)/sigi2(i,1)* phi(i,1) * Xi'*Hi*Xi;
      b=b+phi(i,1)/sigi2(i,1)*Xi'*Hi*(dyi - phi(i,1)*yi_);
   end
   
   betan=inv(A)*b;
   %2. get new phi and sigmai2
   
    phi=zeros(n,1);
    sigi2=zeros(n,1);
    for i=1:n
        [exi,Hi,dyi,Xi,yi_, Ti]=getvars(i,X,Y,p,betan);

        phi(i,1)=inv(exi'*Hi*exi)*exi'*Hi*dyi;
        sigi2(i,1)=(dyi-phi(i,1)*exi)'*Hi*(dyi-phi(i,1)*exi)/(Ti-p);
    end 
    %abs(betan-beta)
   converge=max(abs(betan-beta))<precision;
   beta=betan;
   iter=iter+1;
end

betahat=beta;
% now compute stdev

d=zeros(k,k);
for i=1:n
    [exi,Hi,dyi,Xi,yi_, Ti]=getvars(i,X,Y,p,betan);
    d=d+phi(i,1)*phi(i,1)/sigi2(i,1)*Xi'*Hi*Xi;
end 

AV=inv(d);
 stdbeta=diag(AV^0.5);

 
return

