function [betahat, betavar, betavar1, kappahat, CVs]=ardlpmg_bc(y,x)

[T,n]=size(y);
%% Step 1: estimation of data
% estimate all parameters
Q=ardlpmg_full(y,x);

Th=(T+1)/2;

% generate data
R=5000; % number of replications for simulations
betaall=zeros(R,1); betaalla=zeros(R,1); betaallb=zeros(R,1);
tall=zeros(R,1); sball=zeros(R,1);
tallj1=zeros(R,1);
for r=1:R
    [yr,xr]=gen_data_ardlbc(Q,y(1,:), x(1,:),T);    
    [b,~,~,va]=ardlpmg(yr,xr);
    sb=va^0.5;
    betaall(r,1)=b;
    tall(r,1)=(b-Q.beta)/sb;
    sball(r,1)=sb;
    
    x1r=xr(1:Th,:); y1r=yr(1:Th,:);
    x2r=xr(Th:T,:); y2r=yr(Th:T,:);
    
    betaalla(r,1)=ardlpmg(y1r,x1r);
    betaallb(r,1)=ardlpmg(y2r,x2r);
    % jackknife s.es
    kappa=1/3; p=1;
    [bj, bjv]=ardlpmg_vj(yr,xr, kappa, p);
    tallj1(r,1)=(bj-Q.beta)/(bjv^0.5);
end %r

% compute bias-adjusted estimator and its variance
bias=mean(betaall)-Q.beta; biasa=mean(betaalla)-Q.beta; biasb=mean(betaallb)-Q.beta;
bias2=(biasa+biasb)/2;
betahat= Q.beta-bias;
betavar=var(betaall);
%CVs.simulbased=quantile(abs(tall),0.95);


% now compute alternative variance
sv=0; sx=Q.sx;
sx=sx/(T-1)/(T-1)/n;
for i=1:n
    xi=x(2:T,i);
    yi=y(2:T,i);

    Wi=[y(2:T,i)-y(1:T-1,i),x(2:T,i)-x(1:T-1,i), ones(T-1,1)]; 
    Hi=[y(1:T-1,i),x(2:T,i),x(1:T-1,i), ones(T-1,1)]; 
    P=Hi*inv(Hi'*Hi)*Hi';
    M=P-P*Wi*inv(Wi'*P*Wi)*Wi'*P;
    
    vinm= (yi-betahat*xi);
    sv=sv+((xi'*M*vinm/T)^2)/n;
end
OM=sv/sx/sx;
betavar1=OM/T/T/n;

% now compute kappahat
kappahat=bias/(bias2-bias);


betajackallhat=betaall-kappahat*((betaalla+betaallb)/2-betaall);
tjackhatall=(betajackallhat-Q.beta)./sball;
CVs.jackhat=quantile(abs(tjackhatall),0.95);

 kappa=1/3;
betajackall=betaall-kappa*((betaalla+betaallb)/2-betaall);
tjackall=(betajackall-Q.beta)./sball;
CVs.jack13=quantile(abs(tjackall),0.95);
CVs.jack13_jf=quantile(abs(tallj1),0.95);

tallj2=zeros(R,1);
tallsb=zeros(R,1);
for r=1:R
    [yr,xr]=gen_data_ardlbc(Q,y(1,:), x(1,:),T);    
    % jackknife s.es
    p=1;
    [bj, bjv]=ardlpmg_vj(yr,xr, kappahat, p);
    tallj2(r,1)=(bj-Q.beta)/(bjv^0.5);
    % simul based bias corrected estimator s.e.s
    [b,~,~,va]=ardlpmg(yr,xr);
    sb=va^0.5;
    bbc=b-bias;
    tallsb(r,1)=(bbc-Q.beta)/sb;
end %r
CVs.jackhat_jf=quantile(abs(tallj2),0.95);
CVs.simulbased=quantile(abs(tallsb),0.95);

return